# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
Django settings for presenterclub project.

Generated by 'django-admin startproject' using Django 1.9.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.9/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.9/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

IN_PROD = os.environ.get('ENV', 'dev') == 'prod'
if IN_PROD:
    SECRET_KEY = os.environ['SECRET_KEY']
    DEBUG = False
else:
    print('You are NOT IN PROD')
    print('IF YOU SEE THIS AND YOU ARE IN PROD')
    print('YOU ARE WARNED')

    SECRET_KEY = '8ev)nzt_)+#hyn(dsl1ry%+v*6nwc44-^1-uhyj@e7fdrotz(a'
    DEBUG = True


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.9/howto/deployment/checklist/

ALLOWED_HOSTS = ('*',)

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'anymail',
    'webpack_loader',
    'imagekit',
    'background_task',
    # Presenter Club Applications
    'u',
    'promo',
    'imagesearch',
    'medialibrary',
    'styles',
]

MIDDLEWARE_CLASSES = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'presenterclub.urls'

# Stripe
import stripe
if IN_PROD:
    STRIPE_PK = 'pk_live_40cKrpb9Pwq3je96c0ApcbKd'
    stripe.api_key = os.environ['STRIPE_SK']
else:
    STRIPE_PK = 'pk_test_TDEV2OxM3bWt686yG7mGHKEr'
    stripe.api_key = 'sk_test_K0Jwgp31Cga6R1R6tGDUncM9'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            'templates'
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django_settings_export.settings_export',
            ],
        },
    },
]
SETTINGS_EXPORT = [
    'IN_PROD',
    'STRIPE_PK'
]

WSGI_APPLICATION = 'presenterclub.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.9/ref/settings/#databases

if IN_PROD:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.postgresql_psycopg2',
            'NAME': os.environ['dbname'],
            'USER': os.environ['dbuser'],
            'PASSWORD': os.environ['dbpassword'],
            'HOST': 'localhost',
            'PORT': '',  # Set to empty string for default.
        }
    }
else:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': os.path.join(BASE_DIR, '_DEVEL_DATA', 'db.sqlite3'),
        }
    }


# Password validation
# https://docs.djangoproject.com/en/1.9/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]
AUTHENTICATION_BACKENDS = ['promo.views.LoginBackend']

LOGIN_REDIRECT_URI = '/'


# Internationalization
# https://docs.djangoproject.com/en/1.9/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Australia/Sydney'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.9/howto/static-files/

if IN_PROD:
    STATIC_ROOT = '/var/www/static-presenter.club/'
STATIC_URL = '/static/'
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static")
]

if IN_PROD:
    DEFAULT_FROM_EMAIL = 'server@presenter.club'
    SERVER_EMAIL = 'server@presenter.club'
    EMAIL_BACKEND = 'anymail.backends.mailgun.MailgunBackend'
    ANYMAIL = {
	'MAILGUN_API_KEY': os.environ.get('MAILGUN'),
        'MAILGUN_SEND_DEFAULTS': {
            'esp_extra': {'sender_domain': 'presenter.club'}
        }
    }
else:
    EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'


if IN_PROD:
    MEDIA_ROOT = '/srv/media-presenter.club'
else:
    MEDIA_ROOT = './_DEVEL_DATA/media/'
MEDIA_URL = '/media/'

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
    },
    'loggers': {
        'django': {
            'handlers': ['console'],
            'level': 'ERROR'
        },
    },
}
